<?php

$mainGui =& GUIFactory::setMainGUI("main");

mysession_var_reg("portalid");



$ERROR_LINES_NOT_MATCH = 1;

$ERROR_UNKNOWN_TYPE = 2;

$ERROR_DUPE = 3;

$ERROR_NO_UID = 4;

$ERROR_NO_EMAIL = 5;


$DEMO_USERID = 99999999;

function create_insert_string( $import_fields, $fields )
{
 global $IMPORT_TYPE_STRING, $IMPORT_TYPE_INT, $IMPORT_TYPE_DATE, $IMPORT_TYPE_PW, $IMPORT_TYPE_EXT, $ERROR_UNKNOWN_TYPE;

 $i = 0;
 $ret = "";

 foreach ( $import_fields as $key => $type )
 {
 switch( $type )
 {
 case $IMPORT_TYPE_STRING: 
 $add = "'" . sqlslashes( $fields[$i] ) . "'";
 break;
 case $IMPORT_TYPE_INT: 
 if ( is_numeric( $fields[$i] ) ) $add = $fields[$i];
 else $add = "0";
 break;
 case $IMPORT_TYPE_DATE;
 $imdate = split("/", $fields[$i]);
 $immonth = $imdate[1]; $imday = $imdate[2]; $imyear = $imdate[0];
 $imdate = mktime(0, 0, 0, $immonth, $imday, $imyear);
 $add = $imdate;
 break;
 case $IMPORT_TYPE_PW;
 $add = "password('" . $fields[$i] . "')";
 break;
 case $IMPORT_TYPE_EXT;
 $add = "";
 break;
 default:
 return $ERROR_UNKNOWN_TYPE;
 
 } 
 
 if ( ( $i > 0 ) && ( $type != $IMPORT_TYPE_EXT ) ) $ret .= ", ";

 $ret .= $add;
 $i++;
 }
 return $ret;
}

function nl_get_compare($compare_value = "")
{
 global $IMPORT_FIELDS_USER;

 $i = 0;
 $ret = FALSE;

 foreach ( $IMPORT_FIELDS_USER as $key => $type )
 {
 if ( $key == $compare_value )
 {
 $ret = $i;
 }
 $i++;
 }
 return $ret;
}

function nl_get_group_fieldnr()
{
 global $IMPORT_FIELDS_USER;

 $i = 0;
 $ret = FALSE;

 foreach ( $IMPORT_FIELDS_USER as $key => $type )
 {
 if ( ereg( "group", $key ) )
 {
 $ret = $i;
 }
 $i++;
 }
 return $ret;
}










function import_users( $text, $portalid, $nid, $assign_text, $assign_html, $group_type )
{
 global $PDB, $IMPORT_LINE_SEPARATOR, $IMPORT_FIELDS_USER, $IMPORT_FIELD_SEPARATOR, $table, $output_log, $DEMO_USERID;
 global $ignore_title, $DEBUG, $test_only, $subscribe_too, $partly_import, $import_from, $import_to;
 global $ERROR_LINES_NOT_MATCH, $ERROR_UNKNOWN_TYPE, $ERROR_DUPE, $ERROR_NO_UID, $ERROR_NO_EMAIL, $lang, $FEATURE;

 $group_fieldnr = nl_get_group_fieldnr();

 
 foreach ( $IMPORT_FIELDS_USER as $key => $type )
 {
 if ( !ereg( "group", $key ) ) { $array_inserts[] = $key; }
 $inserts = implode( ", ", $array_inserts );

 }

 
 $field_count = count($IMPORT_FIELDS_USER);
 
 $ret = TRUE;

 
 $lines = explode( $IMPORT_LINE_SEPARATOR, $text );

 $count = 1;

 
 foreach ( $lines as $line )
 {
 
 if ( $ignore_title && !$cont_ignore )
 {
 $cont_ignore = TRUE;
 continue;
 }

 if ( ( $partly_import != "" ) && ( $count < $import_from || $count > $import_to ) )
 {
 $count++;
 continue;
 }
 
 
 $fields = explode( $IMPORT_FIELD_SEPARATOR, $line );
 $save_line = $line;

 
 if ( count($fields) == $field_count )
 {
 $line = create_insert_string( $IMPORT_FIELDS_USER, $fields );
 
 if ( !is_numeric( $line ) )
 {
 if ( $FEATURE["use_login_for_import"] ) $compare_value = nl_get_compare("login");
 else $compare_value = nl_get_compare("email");
 
 if ( $compare_value !== FALSE && $fields[$compare_value] )
 {
 if ( $FEATURE["use_login_for_import"] ) 
 $sql = "SELECT userid FROM " . $table["system_user"] . " WHERE login = '" .
 $fields[$compare_value] . "'";
 else
 $sql = "SELECT userid FROM " . $table["system_user"] . " WHERE email = '" . 
 $fields[$compare_value] . "'";

 if ( !is_array( $MEMBERS_BASE ) ) { $MEMBERS_BASE = array( $portalid ); }
 $where = " AND portalid IN (" . implode( ", ", $MEMBERS_BASE ) . ")";
 $sql .= $where;

 if ( $DEBUG["sql"] ) echo "SELECT: " . $sql . "<br/>";

 $rs = query( $sql, $PDB );

 $uuserid = $rs["arr"][0]["userid"];

 if ( $rs["num"] <= 0 ) 
 {
 
 
 $sql = "INSERT INTO " . $table["system_user"] . " ( $inserts, create_time, " .
 "portalid, newsletter, last_login ) VALUES ( $line, ". time() .
 ", $portalid, 1, " . time() . " )";
 
 if ( !$test_only )
 {
 if ( $DEBUG["sql"] ) { echo "INSERT: " . $sql . "<br>"; }
 $rs = query( $sql, $PDB );
 $iid = $rs["iid"];
 if ( $subscribe_too && $uuserid ) $iid = $uuserid;

 
 if ( $group_fieldnr != FALSE && $fields[$group_fieldnr] )
 {
 $sql = "SELECT * FROM " . $table["system_user_group"] . 
 " WHERE userid = " . $iid . " AND groupid = " .
 $fields[$group_fieldnr];
 $rs = query( $sql, $PDB );

 if ( $rs["num"] == 0 )
 {
 $sql = "INSERT INTO " . $table["system_user_group"] .
 "(userid, groupid) VALUES (" . $iid . ", " .
 $fields[$group_fieldnr] . ")";
 if ( $DEBUG["sql"] ) { echo "INSERT: " . $sql . "<br>"; }
 $rs = query( $sql, $PDB );
 }
 }
 } else
 {
 $iid = $DEMO_USERID;
 }
 
 } else
 {
 $ret = $ERROR_DUPE;
 $output_log .= "<tr><td><font color=\"red\">ERROR (" . $ret . ") [" . 
 $lang[60040] . "]</font></td><td>" . $save_line . "</td></tr>";
 }

 if ( ( $uuserid && $subscribe_too ) || $iid )
 {
 if ( $subscribe_too && $uuserid ) $iid = $uuserid;

 if ( $uuserid && !$test_only )
 {
 $sql = "SELECT * FROM " . $table["newsletter_subscribe"] . 
 " WHERE ngid = " . $nid . " AND userid = " . $uuserid;
 $rs = query( $sql, $PDB );
 if ( $rs["num"] > 0 )
 {
 $sql = "DELETE FROM ". $table["newsletter_subscribe"] .
 " WHERE ngid = " . $nid . " AND userid = " . $uuserid;
 if ( $DEBUG["sql"] ) { echo "DELETE: " . $sql . "<br>"; }
 $rs = query( $sql, $PDB );
 }
 }
 
 
 if ( $assign_text )
 {
 $sql = "INSERT INTO " . $table["newsletter_subscribe"] . 
 " ( ngid, userid, format, subdate, type )" .
 " VALUES ( $nid, $iid, 1, ". time() .", $group_type )";
 if ( $DEBUG["sql"] ) { echo "INSERT: " . $sql . "<br>"; }
 if ( !$test_only ) $rs = query( $sql, $PDB );
 }

 
 if ( $assign_html )
 {
 $sql = "INSERT INTO " . $table["newsletter_subscribe"] .
 " ( ngid, userid, format, subdate, type ) " .
 "VALUES ( $nid, $iid, 2, ". time() .", $group_type )";
 if ( $DEBUG["sql"] ) { echo "INSERT: " . $sql . "<br>"; }
 if ( !$test_only ) $rs = query( $sql, $PDB );
 }
 $output_log .= "<tr><td><font color=\"green\">OK [" . $lang[60050] . "]</font></td><td>" . $save_line . "</td></tr>";
 } else
 {
 $ret = $ERROR_NO_UID;
 $output_log .= "<tr><td><font color=\"red\">ERROR (" . $ret . ") [" . $lang[60060] . "]</font></td><td>" . $save_line . "</td></tr>";
 }
 } else
 {
 $ret = $ERROR_NO_EMAIL;
 $output_log .= "<tr><td><font color=\"red\">ERROR (" . $ret . ") [" . $lang[60070] . "]</font></td><td>" . $save_line . "</td></tr>";
 }
 } else
 {
 
 $ret = $line;
 $output_log .= "<tr><td><font color=\"red\">ERROR (" . $ret . ") [" . $lang[60080] . "]</font></td><td>" . $save_line . "</td></tr>";
 }

 } else if ( count($fields) > 1 )
 {
 $ret = $ERROR_LINES_NOT_MATCH; 
 $output_log .= "<tr><td><font color=\"red\">ERROR (" . $ret . ") [" . $lang[60090] . "]</font></td><td>" . $save_line . "</td></tr>";
 }
 flush;
 $count++;

 }
 return $ret;
}




$f = $HI["file"];
$f["label"] = i18n('source_file'); 
$f["var"] = "import";
$hi[] = $f;

$f = $HI["checkbox"];
$f["label"] = $lang[5997]; 
$f["var"] = "assign_text";
$hi[] = $f;

$f = $HI["checkbox"];
$f["label"] = $lang[5998]; 
$f["var"] = "assign_html";
$hi[] = $f;

$f = $HI["checkbox"];
$f["label"] = $lang[60100];
$f["var"] = "test_only";
$hi[] = $f;

$f = $HI["checkbox"];
$f["label"] = $lang[60110];
$f["var"] = "subscribe_too";
$hi[] = $f;

$f = $HI["checkbox"];
$f["label"] = $lang[60120];
$f["var"] = "ignore_title";
$hi[] = $f;

$f = $HI["checkbox"];
$f["label"] = $lang[60130];
$f["var"] = "partly_import";
$hi[] = $f;

$f = $HI["text"];
$f["label"] = $lang[60140];
$f["var"] = "import_from";
$f["optional"] = true;
$hi[] = $f;

$f = $HI["text"];
$f["label"] = $lang[60150];
$f["var"] = "import_to";
$f["optional"] = true;
$hi[] = $f;

$f = $HI["ok"];
$f["label"] = $lang[5995]; 
$hi[] = $f;

$f = $HI["hidden"];
$f["var"] = "nid";
$hi[] = $f;

$import_dialog = new htmlform($hi);



$sql = "SELECT name, type AS ntype FROM  " . $table["newsletter_list"] . " WHERE id = $nid";

$rs = query( $sql, $PDB );

$group_name = $rs["arr"][0]["name"];
$group_type = $rs["arr"][0]["ntype"];

if ( !$group_type ) $group_type = 1;

$do_import=false;

if($faction == "ok")
{
 
 if($FEATURE["user_importexport_permissions"]==TRUE)
 {
 if(perm($USER_ID,$T_NEWSLETTER_GROUP_START,$portalid.$T_NEWSLETTER_GROUP_START,2))
 {
 $do_import = true; 
 }
 
 }
 else
 {
 $do_import = true;
 }
 
}


if ( $do_import ==true )
{

 $output_log = "<center><table border=\"1\" width=\"400\">";

 $STAMP["start"] = time();
 
 $code = import_users($import, $portalid, $nid, $assign_text, $assign_html, $group_type );
 
 $STAMP["end"] = time();



 $output_log .="</table><table border=\"0\" width=\"400\"><tr><td>" . $STAMP["start"] . 
 " " . $STAMP["end"] . " == " . ( $STAMP["end"] - $STAMP["start"] ) . " sec.</td></tr></table></center>";
 echo $output_log;

}

load_menu(72605, $T_NEWSLETTER_GROUP, 1, $lang[5160].":<br><b>" . strtoupper($group_name) . "</b></SUP>", 0, "nid=$nid" );



?>
