<?




class ObjectSelectionStore extends BaseObject {
 
 var $objectStore = array();

 
 var $typeStore = array();

 function getSerializeKey() {
 return array(
 "objectstore" => array_node_serialize( $this->objectStore),
 "typestore" => array_node_serialize( $this->typeStore)
 );
 }

 function initFromSerializeKey( $key ) {
 $this->objectStore = &array_node_unserialize( $key["objectstore"] );
 $this->typeStore = &array_node_unserialize( $key["typestore"] );
 }

 



 function setKey($key) {
 $pieces = $this->_parseKey($key);
 if (count($pieces) > 1) {
 
 if (!$this->objectStore[$pieces[0]]) {
 $this->objectStore[$pieces[0]] = array();
 }
 $this->objectStore[$pieces[0]][$pieces[1]] = true;

 
 if ($pieces[0] == T_PAGE && count($pieces) > 2 && $pieces[2] == 'a') {
 
 $langvars = get_language_variants($pieces[1], null, true);
 foreach ( $langvars as $langvar ) {
 $this->setKey(T_PAGE."_${langvar}");
 }
 }
 } else {
 
 $this->typeStore[$pieces[0]] = true;
 }
 }

 



 function unsetKey($key) {
 $pieces = $this->_parseKey($key);
 if (count($pieces) > 1) {
 
 if ($this->objectStore[$pieces[0]]) {
 unset($this->objectStore[$pieces[0]][$pieces[1]]);
 }

 
 if ($pieces[0] == T_PAGE && count($pieces) > 2 && $pieces[2] == 'a') {
 
 $langvars = get_language_variants($pieces[1], null, true);
 foreach ( $langvars as $langvar ) {
 $this->unsetKey(T_PAGE."_${langvar}");
 }
 }
 } else {
 
 unset($this->typeStore[$pieces[0]]);
 }
 }

 



 function issetKey($key) {
 $pieces = $this->_parseKey($key);
 if (count($pieces) > 1) {
 
 return $this->objectStore[$pieces[0]] && $this->objectStore[$pieces[0]][$pieces[1]];
 } else {
 
 return $this->typeStore[$pieces[0]];
 }
 }

 function _parseKey($key) {
 $key = str_replace(".", "_", $key);
 if (substr( $key, strlen( $key ) - 2) === "_a") {
 return explode("_", $key);
 } else {
 return explode("_", $key, 2);
 }
 }
}

?>
